#!/usr/bin/perl -w

# LSB Test Execution Framework
# Administration Page Module (tests_admin.pl)
#
# Copyright (C) 2007-2009 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
# The ptyshell tool is originally written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use TestStatus;
use Fcntl ':flock';

print "HTTP/1.0 200 OK" . CRLF;
print "Content-type: text/html" . CRLF . CRLF;

print_header('LSB Distribution Testkit Administration', 'admin');

print "<h1>LSB Distribution Testkit Administration</h1>\n";

my $error_text = '';

my $log_file = "$SERVER_PARAM{'APP_DATA'}/log/dtk-server.log.$SERVER_PARAM{'PORT'}";
my $serv_pid = $SERVER_PARAM{'SERVER_PID'};

my $serv_status;
my $serv_stop_button;
if ($serv_pid) {
	$serv_status = "<font color=\"green\">Running</font> (PID: $serv_pid)";
	$serv_stop_button = " onclick=\"javascript:onStopServer($serv_pid, 'server');\"";
}
else {
	$serv_status = '<b><font color="red">PID not found!</font></b>';
	$serv_stop_button = ' disabled="disabled"';
}

my $test_status;
my $test_stop_button;
my $running = 0;
if (lock_status()) {
	my $status = read_status();
	$running = $status->{'IS_RUNNING'};
	if ($running) {
		$test_status = "<font color=\"green\">Running</font> (PID: $status->{'PID'})";
		$test_stop_button = " onclick=\"javascript:onStopServer($status->{'PID'}, 'tests');\"";
	}
	else {
		$test_status = '<font color="red">Not running</font>';
		$test_stop_button = ' disabled="disabled"';
	}
	unlock_status();
}
else {
	$error_text = "Error locking the status file!<br />$status_error";
	$test_status = '<b><font color="red">PID not found!</font></b>';
	$test_stop_button = ' disabled="disabled"';
}

print show_error_dlg($error_text);

print <<DATA;
<div id="ajax_loading" style="display: none; position: fixed; width: 13em; height: 5.8em; top: 40%; left: 50%; margin-top: -2.9em; margin-left: -7.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; padding: 6px;"><div align="center">
Please wait&hellip;<br />
<img src="images/environment-spacer.gif" width="1" height="5" alt="" /><br />
<img src="images/ajax_progress.gif" width="16" height="16" alt="" /><br />
<img src="images/environment-spacer.gif" width="1" height="7" alt="" /><br />
<input type="button" name="ajax_abort" id="ajax_abort" value="Abort" style="border: solid 1px #00007f; background: #e0e0ff; color: blue; width: 6em;" onclick="javascript:onAbort();" />
</div></div>

<div id="disable_layer" style="display: none; position: fixed; width: 100%; height: 100%; top: 0px; left: 0px; background-color: gray; opacity: 0.4; filter: alpha(opacity=40);"></div>

<table cellpadding="0" cellspacing="0" id="server_stopped" style="display: none; position: fixed; width: 25em; height: 6em; top: 40%; left: 50%; margin-top: -3em; margin-left: -12.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; vertical-align: middle; padding: 6px;"><tr><td>
<font size="+2" color="red"><b>Server is stopped</b></font>
</td></tr></table>

<table cellpadding="0" cellspacing="0" border="0" style="width: 50em;">
  <tr>
    <td valign="top" width="100%">
      <table cellpadding="0" cellspacing="0" border="0" width="100%">
        <tr>
          <td style="border: solid 1px #606090; background: #e0e0ff; text-align: center; font-size: large; padding: 0.3em;">Status</td>
        </tr>
        <tr>
          <td style="border: solid 1px #606090; border-top: none; vertical-align: top; padding: 10px;">
            <table class="main" cellpadding="2" cellspacing="2">
              <tr>
                <td style="width: 8em;">Server status:</td>
                <td style="width: 12.5em;" id="server_status">$serv_status</td>
                <td><input type="button" id="server_stop" style="width: 7.5em;" value="Stop server"$serv_stop_button /></td>
              </tr>
              <tr>
                <td>Tests status:</td>
                <td id="tests_status">$test_status</td>
                <td><input type="button" id="tests_stop" style="width: 7.5em;" value="Stop tests"$test_stop_button /></td>
              </tr>
            </table>
            <br />
            <a href="/get.pl$log_file" target="_blank">View server log</a>
          </td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td><img src="images/environment-spacer.gif" width="1" height="20" border="0" alt="" /></td>
  </tr>
  <tr>
    <td valign="top" width="100%">
      <table cellpadding="0" cellspacing="0" border="0" width="100%">
        <tr>
          <td style="border: solid 1px #606090; background: #e0e0ff; text-align: center; font-size: large; padding: 0.3em;">Server Configuration</td>
        </tr>
        <tr>
          <td style="border: solid 1px #606090; border-top: none; vertical-align: top; padding: 10px;">
            Proxy server for connecting to the Linux Foundation FTP:<br />
            <input type="text" name="proxy" id="proxy" value="$SERVER_PARAM{'PROXY'}" style="width: 35em;" onfocus="javascript:style.borderColor=input_border_color;" /><br />
            <br />
            <input type="button" name="apply_button" id="apply_button" value="Apply" style="width: 7em;" onclick="javascript:onSettingsApply();" />&nbsp;&nbsp;&nbsp;<input type="button" name="clear_button" id="clear_button" value="Clear" style="width: 7em;" onclick="javascript:onSettingsClear();" /><span id="conf_saved_msg" style="display: none;">&nbsp;&nbsp;&nbsp;<b>Configuration saved</b></span>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Preload some images that are not initially visible
preload_images(new Array('expand.png', 'collapse.png', 'ajax_progress.gif'));
var input_border_color = ((navigator.appName == 'Konqueror') ? '#cccccc' : '');

// AJAX
function onStopServer(pid, what) {
	if (!ajax_req_busy) {
		if (confirm('Do you really want to kill the process tree (PID: ' + pid + ')?')) {
			ajax_call_get('action=stop_tests&tree=' + what);
		}
	}
}

function onSettingsApply() {
	if (!ajax_req_busy) {
		var elem = document.getElementById('proxy');
		if (!elem)
			return;
		if ((elem.value != '') && (elem.value.search(/^[A-Za-z0-9\\-_.]+:\\d+\$/) != 0)) {
			elem.style.borderColor = 'red';
			alert('Invalid format for proxy. Should be host:port.');
			return;
		}
		ajax_call_get('action=server_control&proxy=' + encodeURIComponent(elem.value));
	}
}

function onSettingsClear() {
	if (confirm('Are you sure you want to clear the settings?')) {
		var elem = document.getElementById('proxy');
		if (elem)
			elem.value = '';
	}
}

function ajaxProcessResult(responseXML) {
	if (responseXML.getElementsByTagName('stopped').length > 0) {
		var stopped = responseXML.getElementsByTagName('stopped')[0].childNodes[0].nodeValue;
		var what = responseXML.getElementsByTagName('stopped')[0].getAttribute('id');
		var server_status = document.getElementById('server_status');
		var server_stop = document.getElementById('server_stop');
		var tests_status = document.getElementById('tests_status');
		var tests_stop = document.getElementById('tests_stop');
		if (server_status && server_stop && tests_status && tests_stop) {
			if (what == 'tests') {
				tests_status.innerHTML = '<font color="red">Not running</font>';
				tests_stop.disabled = true;
			}
			else if (what == 'server') {
				server_status.innerHTML = '<font color="red">Not running</font>';
				server_stop.disabled = true;
				tests_status.innerHTML = '<font color="red">Not running</font>';
				tests_stop.disabled = true;
				var server_stopped = document.getElementById('server_stopped');
				server_stopped.style.display = '';
				var show_disable_layer = true;
				if (navigator.appName == 'Konqueror') {
					show_disable_layer = false;
				}
				else if (navigator.appName == 'Microsoft Internet Explorer') {
					var idx = navigator.appVersion.indexOf('MSIE ');
					if (idx == -1) {
						show_disable_layer = false;
					}
					else {
						if (navigator.appVersion.substr(idx + 5, 1) < '7')
							show_disable_layer = false;
					}
				}
				if (show_disable_layer)
					document.getElementById('disable_layer').style.display = '';
			}
		}
	}
	else if (responseXML.getElementsByTagName('serverupd').length > 0) {
		new fadeOut('conf_saved_msg', 0, 128, 0, 255, 255, 255, true);
	}
}
// ]]>
</script>
DATA

print_footer();
